/**********************************************************************
report any bugs to: klee@informatik.unibw-muenchen.de
**********************************************************************/

/**********************************************************************

showjava: disassembler for java class files (Version 0.01, 26.6.96)

usage: showjava infile outfile
  infile: JAVA class file
  outfile: textfile
  if no outfile is given, stdout is used
  no wildcards are allowed in filename
  
**********************************************************************/


/**********************************************************************

 int must be 4 bytes
 
 only this external functions or types are used:

 FILE
 stdout
 fopen()    : text
 fopenb()   : binary
 fclose()
 getc()
 putc()
 exit()

**********************************************************************/


#include <stdio.h>

#ifndef NULL
#define NULL 0
#endif 

#define bufmax 1024

FILE *cla, *lst, *fopen(), *fopenb();
int posf=0,posb=0, posx=0, posn=0;
int nested[10];
unsigned char buf[bufmax+1];

int  SourceFile=0,
     ConstantValue=0,
     Code=0,
     Exeption=0,
     LineNumberTable=0,
     LocalVariableTable=0;


/***********************************************************************/

main(nargs,args) int nargs; char *args[];
{char ch;
 int i,j,k,l;

 if (nargs!=2 && nargs!=3) ende(1,13);
 cla = fopen(args[1],"rb");  if (cla==NULL) ende(2,1);
 if (nargs==3) {lst = fopen(args[2],"w");   if (lst==NULL) ende(3,2);}
          else {lst=stdout;} 

/*---------------------------------------------------------------------*/
 if ((i=get4()) != 0xcafebabe) ende(4,4);
           out_code(); out_string("magic           : "); out_hex4(i); 
/*---------------------------------------------------------------------*/
 i=get2(); out_code(); out_string("minor_version   : "); 
           out_hex2(i); out_string(" ("); out_dec2(i); out_string(")");
/*---------------------------------------------------------------------*/
 i=get2(); out_code(); out_string("major_version   : "); 
           out_hex2(i); out_string(" ("); out_dec2(i); out_string(")");
/*---------------------------------------------------------------------*/
 i=get2(); out_code(); out_string("const_pool_count: ");
           out_hex2(i); out_string(" ("); out_dec2(i); out_string(")\n");
 posn++;
 for (nested[posn]=1; nested[posn] < i; nested[posn]++)
  {j=get1(); 
   switch(j) { 
    case 1 : j=get2(); l=posb; for (k=0;k<j;k++) get1(); out_code(); 
             out_string("Utf8: "); 
             j=utf8_to_text(buf+l,j); test_for_attr_name(buf+l,j);
             for (k=l; k<l+j; k++) out_byte(buf[k]); break;
    case 2 : j=get2(); l=posb; for (k=0;k<j;k++) get1(); out_code(); 
             out_string("Unicode: "); 
             j=unicode_to_text(buf+l,j);
             for (k=l; k<l+j; k++) out_byte(buf[k]); break;
    case 3 : j=get4(); out_code(); out_string("Integer   "); 
             out_hex4(j); break;
    case 4 : j=get4(); out_code(); out_string("Float     "); 
             out_hex4(j); break;
    case 5 : j=get4(); k=get4(); out_code(); out_string("Long      "); 
             out_hex4(j); out_hex4(k); nested[posn]++; break;
    case 6 : j=get4(); k=get4(); out_code(); out_string("Double    "); 
             out_hex4(j); out_hex4(k); nested[posn]++; break;
    case 7 : j=get2(); out_code(); out_string("Class     name : "); 
             out_hex2(j); break;
    case 8 : j=get2(); out_code(); out_string("String    text : "); 
             out_hex2(j); break;
    case 9 : j=get2(); k=get2(); out_code(); out_string("Fieldref  class: "); 
             out_hex2(j); out_string("  name+typ : "); out_hex2(k); break;
    case 10: j=get2(); k=get2(); out_code(); out_string("Methodref class: "); 
             out_hex2(j); out_string("  name+typ : "); out_hex2(k); break;
    case 11: j=get2(); k=get2(); out_code(); out_string("Interface class: "); 
             out_hex2(j); out_string("  name+typ: "); out_hex2(k); break;
    case 12: j=get2(); k=get2(); out_code(); out_string("Name+Typ  name : "); 
             out_hex2(j); out_string("  signature: "); out_hex2(k); break;
    
    default: ende(5,6);
   }
  }
 posn--; out_string("\n");

/*---------------------------------------------------------------------*/
 i=get2(); out_code(); out_string("access_flags: "); out_flags(i);
/*---------------------------------------------------------------------*/
 i=get2(); out_code(); out_string("this_class  : "); out_hex2(i); 
/*---------------------------------------------------------------------*/
 i=get2(); out_code(); out_string("super_class : "); out_hex2(i);
/*---------------------------------------------------------------------*/

 i=get2(); out_code(); out_string("interf_count: ");
           out_hex2(i); out_string(" ("); out_dec2(i); out_string(")");
 if (i) {posn++;
         for (nested[posn]=0; nested[posn] < i; nested[posn]++) 
          {j=get2(); out_code(); out_string("interface   : "); out_hex2(j);} 
         posn--; out_string("\n");
        }

/*---------------------------------------------------------------------*/

 i=get2(); out_code(); out_string("field_count : ");
           out_hex2(i); out_string(" ("); out_dec2(i); out_string(")");
 if (i) {posn++;
         for (nested[posn]=0; nested[posn] < i; nested[posn]++) 
          {j=get2(); out_code(); out_string("flags       : "); out_flags(j);
           j=get2(); out_code(); out_string("name        : "); out_hex2(j); 
           j=get2(); out_code(); out_string("signature   : "); out_hex2(j); 
           j=get2(); out_code(); out_string("attrib_count: "); out_hex2(j); 
           if (j) {posn++;
                   for (nested[posn]=0; nested[posn] < j; nested[posn]++) 
                       out_attr();
                   posn--; out_string("\n");
                  } 
          } 
         posn--; out_string("\n");
        }
/*---------------------------------------------------------------------*/

 i=get2(); out_code(); out_string("methods_count:");
           out_hex2(i); out_string(" ("); out_dec2(i); out_string(")");
 if (i) {posn++;
         for (nested[posn]=0; nested[posn] < i; nested[posn]++) 
           {j=get2(); out_code(); out_string("flags       : "); out_flags(j);
            j=get2(); out_code(); out_string("name        : "); out_hex2(j); 
            j=get2(); out_code(); out_string("signature   : "); out_hex2(j); 
            j=get2(); out_code(); out_string("attrib_count: "); out_hex2(j); 
            
            if (j) {posn++;
                    for (nested[posn]=0; nested[posn] < j; nested[posn]++) 
                    out_attr();
                    posn--; out_string("\n");
                   }
           }
         posn--; out_string("\n");
        } 
/*---------------------------------------------------------------------*/
            
 i=get2(); out_code(); out_string("attrib_count= "); out_hex2(i); 
 if (i) {posn++;
         for (nested[posn]=0; nested[posn] < i; nested[posn]++)  out_attr();
         posn--; out_string("\n");
        } 

 ende(6,0);
}

/***********************************************************************/

int unicode_to_text(ptr,j) unsigned char *ptr; int j;
{unsigned char *p, *q;
 int i;

 if (j&1) ende(7,14);
 j=j/2; p=ptr; q=ptr; 
 for (i=0;i<j;i++)
  {if (*p++) {*q++='?'; p++;}
   else      {*q++=*p++;    }
  }
 return j;
}
 
/***********************************************************************/

int utf8_to_text(ptr,j) unsigned char *ptr; int j;
{unsigned char *p, *q;
 int i;
 p=ptr; q=ptr;
 
 while (p<ptr+j)
   {switch ((*p & 0xf0)>>4)
     {case  0: if (! *p) ende(8,12);
      case  1:
      case  2:
      case  3:
      case  4:
      case  5:
      case  6:
      case  7: *q++ = *p++;break;
      case  8:
      case  9:
      case 10:
      case 11: ende(9,12);
      case 12: 
      case 13: i = *p++ & 0x1f; 
               if (!((*p & 0xc0) ^ 0x80)) ende(10,12); 
               i= (i<<6) + (*p++ & 0x3f); 
               if (i>255) i='?'; *q++=i; break;
      case 14: i = *p++ & 0x0f; 
               if (!((*p & 0xc0) ^ 0x80)) ende(11,12); 
               i= (i<<6) + (*p++ & 0x3f); 
               if (!((*p & 0xc0) ^ 0x80)) ende(12,12); 
               i= (i<<6) + (*p++ & 0x3f); 
               if (i>255) i='?'; *q++=i; break;
      case 15: ende(13,12);
     }
   }   
 if (p != ptr+j) ende(14,12);
 return q-ptr;
}

/***********************************************************************/

int test_for_attr_name(p,j) char *p; int j;
{if      (cmpstr(p,"SourceFile",j) )         SourceFile=nested[posn];
 else if (cmpstr(p,"ConstantValue",j) )      ConstantValue=nested[posn];
 else if (cmpstr(p,"Code",j) )               Code=nested[posn];
 else if (cmpstr(p,"Exeption",j) )           Exeption=nested[posn];
 else if (cmpstr(p,"LineNumberTable",j) )    LineNumberTable=nested[posn];
 else if (cmpstr(p,"LocalVariableTable",j) ) LocalVariableTable=nested[posn];
}

/***********************************************************************/

int cmpstr(p,q,j) char *p,*q; int j;
{int i;
 for (i=0; i<j; i++) if (*p++ != *q++) return(0);
 if(*q) return(0);
 return(1);
} 

/***********************************************************************/

int get1() {int i; if ( (i=getc(cla)) == EOF) ende(15,3); buf[posb++]=i; 
            if (posb==bufmax) ende(16,5); posf++; return(i);} 
int get2() {int i; i=get1(); return( (i<<8 ) + get1());} 
int get4() {int i; i=get2(); return( (i<<16) + get2());} 

/***********************************************************************/

int out_string(p) char *p; {while (*p) out_byte(*p++);}
int out_hex1(i)   int i; { static char hex[] = {'0','1','2','3','4','5',
                  '6','7','8','9','a','b','c','d','e','f'}; 
                  out_byte(hex[(i>>4)&15]); out_byte(hex[i&15]);}
int out_hex2(i)   int i; {out_hex1(i>>8); out_hex1(i&0xff);}
int out_hex4(i)   int i; {out_hex2(i>>16); out_hex2(i&0xffff);}
int out_dec1(i)   int i; {out_dec4(i&0xff);}
int out_dec2(i)   int i; {out_dec4(i&0xffff);}
int out_dec4(i)   int i; {int k,j=1; if (i<0) {putc('-',lst); i = -i;}
                  k=i; while (k /= 10) j *= 10; while (j) {k=i/j;
                  out_byte(k+'0',lst); i -= k*j; j /= 10;}}
int out_pos(i)    int i; { while (posx<i) out_byte(' ');}
int out_byte(i)   int i; {putc(i,lst); posx++; if ((i&255)=='\n') posx=0;}

/***********************************************************************/

int out_code()
{int i;
 out_string("\n");
 out_hex2(posf-posb); out_string(" : "); 
 for (i=0; i<posb; i++) {if (posx>22) out_string("\n       "); 
                         out_hex1(buf[i]);}
 out_pos(24);
 for (i=1; i<=posn; i++) 
    {out_string("["); out_hex2(nested[i]); out_string("] ");}
 posb=0;
}

/***********************************************************************/

int out_flags(i) int i;
{if (i&0x0001) out_string("PUBLIC ");
 if (i&0x0002) out_string("PRIVAT  ");
 if (i&0x0004) out_string("PROTECTED ");
 if (i&0x0008) out_string("STATIC ");
 if (i&0x0010) out_string("FINAL ");
 if (i&0x0020) out_string("SYNCHRONIZED ");
 if (i&0x0040) out_string("VOLITALE ");
 if (i&0x0080) out_string("TRANSIENT ");
 if (i&0x0100) out_string("NATIVE ");
 if (i&0x0200) out_string("INTERFACE ");
 if (i&0x0400) out_string("ABSTRACT ");
}

/***********************************************************************/

int out_attr() 
{int i,j;
 i=get2(); out_code(); out_string("name        : "); out_hex2(i);

 if      (i==SourceFile) 
   { out_string("   (SourceFile)");
     i=get4(); out_code(); out_string("length      : "); out_hex4(i);
     if (i!=2) ende(17,7);
     i=get2(); out_code(); out_string("file        : "); out_hex2(i);
   }
 else if (i==ConstantValue)
   { out_string("   (ConstantValue)");
     i=get4(); out_code(); out_string("length      : "); out_hex4(i);
     if (i!=2) ende(18,7);
     i=get2(); out_code(); out_string("const       : "); out_hex2(i);
   }
 else if (i==Code)
   { out_string("   (Code)"); 
     i=get4(); out_code(); out_string("length      : "); out_hex4(i);
     i=get2(); out_code(); out_string("max_stack   : "); out_hex2(i);
     i=get2(); out_code(); out_string("max_local   : "); out_hex2(i);
     i=get4(); out_code(); out_string("codelength  : "); out_hex4(i);
     out_ass(i);
     i=get2(); out_code(); out_string("excep_length: "); out_hex2(i);
     if (i) {posn++;
             for (nested[posn]=0; nested[posn]<i; nested[posn]++) 
              {j=get2(); out_code(); out_string("start_pc    : "); out_hex2(j);
               j=get2(); out_code(); out_string("end_pc      : "); out_hex2(j);
               j=get2(); out_code(); out_string("handler_pc  : "); out_hex2(j);
               j=get2(); out_code(); out_string("catch_type  : "); out_hex2(j);
              } 
             posn--;  out_string("\n");
            }
     i=get2(); out_code(); out_string("attrib_count: "); out_hex2(i); 
     if (i);{posn++;
             for (nested[posn]=0; nested[posn] < i; nested[posn]++)  
              out_attr(); 
             posn--;  out_string("\n");
            }
   }
 else if (i==Exeption)
   { out_string("   (Exeption)");
     i=get4(); out_code(); out_string("length      : "); out_hex4(i);
     i=get2(); out_code(); out_string("num_of_entry: "); out_hex2(i);
     if (i) {posn++;
             for (nested[posn]=0; nested[posn]<i; nested[posn]++) 
              {j=get2(); out_code(); out_string("exception   : "); out_hex2(j);
              } 
             posn--;  out_string("\n");
            }
   }

 else if (i==LineNumberTable)
   { out_string("   (LineNumberTable)");
     i=get4(); out_code(); out_string("length      : "); out_hex4(i);
     i=get2(); out_code(); out_string("num_of_entry: "); out_hex2(i);
     if (i) {posn++;
             for (nested[posn]=0; nested[posn]<i; nested[posn]++) 
              {j=get2(); out_code(); out_string("start_pc    : "); out_hex2(j);
               j=get2(); out_code(); out_string("line_nr     : "); out_hex2(j);
              } 
             posn--;  out_string("\n");
            }
   }
 else if (i==LocalVariableTable) 
   { out_string("   (LocalVariableTable)");
     i=get4(); out_code(); out_string("length      : "); out_hex4(i);
     i=get2(); out_code(); out_string("num_of_entry: "); out_hex2(i);
     if (i) {posn++;
             for (nested[posn]=0; nested[posn]<i; nested[posn]++) 
              {j=get2(); out_code(); out_string("start_pc    : "); out_hex2(j);
               j=get2(); out_code(); out_string("length      : "); out_hex2(j);
               j=get2(); out_code(); out_string("name        : "); out_hex2(j);
               j=get2(); out_code(); out_string("signat      : "); out_hex2(j);
               j=get2(); out_code(); out_string("slot        : "); out_hex2(j);
              } 
             posn--;  out_string("\n");
            }
   } 
 else
   { out_string("(unknown attribute)");
     i=get4(); out_code(); out_string("length= "); out_hex4(i);
     for (j=0; j<i; j++) get1(); out_code();
   }
  
}

/***********************************************************************/

int out_ass(i) int i;
{int j,k,l,m,n,o;
 static char *(mnem[]) = {
/*00              */ "nop",
/*01              */ "aconst_null",
/*02              */ "iconst_ml",
/*03              */ "iconst_0",
/*04              */ "iconst_1",
/*05              */ "iconst_2",
/*06              */ "iconst_3",
/*07              */ "iconst_4",
/*08              */ "iconst_5",
/*09              */ "lconst_0",
/*0a              */ "lconst_1",
/*0b              */ "fconst_0",
/*0c              */ "fconst_1",
/*0d              */ "fconst_2",
/*0e              */ "dconst_0",
/*0f              */ "dconst_1",
/*10 xx           */ "bipush            ",
/*11 xxxx         */ "sipush          ",
/*12 xx           */ "ldc1              ",
/*13 xxxx         */ "ldc2            ",
/*14 xxxx         */ "ldc2w           ",
/*15 xx           */ "iload             ",
/*16 xx           */ "lload             ",
/*17 xx           */ "fload             ",
/*18 xx           */ "dload             ",
/*19 xx           */ "aload             ",
/*1a              */ "iload_0",
/*1b              */ "iload_1",
/*1c              */ "iload_2",
/*1d              */ "iload_3",
/*1e              */ "lload_0",
/*1f              */ "lload_1",
/*20              */ "lload_2",
/*21              */ "lload_3",
/*22              */ "fload_0",
/*23              */ "fload_1",
/*24              */ "fload_2",
/*25              */ "fload_3",
/*26              */ "dload_0",
/*27              */ "dload_1",
/*28              */ "dload_2",
/*29              */ "dload_3",
/*2a              */ "aload_0",
/*2b              */ "aload_1",
/*2c              */ "aload_2",
/*2d              */ "aload_3",
/*2e              */ "iaload",
/*2f              */ "laload",
/*30              */ "faload",
/*31              */ "daload",
/*32              */ "aaload",
/*33              */ "baload",
/*34              */ "caload",
/*35              */ "saload",
/*36 xx           */ "istore            ",
/*37 xx           */ "lstore            ",
/*38 xx           */ "fstore            ",
/*39 xx           */ "dstore            ",
/*3a xx           */ "astore            ",
/*3b              */ "istore_0",
/*3c              */ "istore_1",
/*3d              */ "istore_2",
/*3e              */ "istore_3",
/*3f              */ "lstore_0",
/*40              */ "lstore_1",
/*41              */ "lstore_2",
/*42              */ "lstore_3",
/*43              */ "fstore_0",
/*44              */ "fstore_1",
/*45              */ "fstore_2",
/*46              */ "fstore_3",
/*47              */ "dstore_0",
/*48              */ "dstore_1",
/*49              */ "dstore_2",
/*4a              */ "dstore_3",
/*4b              */ "pstore_0",
/*4c              */ "pstore_1",
/*4d              */ "pstore_2",
/*4e              */ "pstore_3",
/*4f              */ "iastore",
/*50              */ "lastore",
/*51              */ "fastore",
/*52              */ "dastore",
/*53              */ "aastore",
/*54              */ "bastore",
/*55              */ "castore",
/*56              */ "sastore",
/*57              */ "pop",
/*58              */ "pop2",
/*59              */ "dup",
/*5a              */ "dup_x1",
/*5b              */ "dup_x2",
/*5c              */ "dup2",
/*5d              */ "dup2_x1",
/*5e              */ "dup2_x2",
/*5f              */ "swap",
/*60              */ "iadd",
/*61              */ "ladd",
/*62              */ "fadd",
/*63              */ "dadd",
/*64              */ "isub",
/*65              */ "lsub",
/*66              */ "fsub",
/*67              */ "dsub",
/*68              */ "imul",
/*69              */ "lmul",
/*6a              */ "fmul",
/*6b              */ "dmul",
/*6c              */ "idiv",
/*6d              */ "ldiv",
/*6e              */ "fdiv",
/*6f              */ "ddiv",
/*70              */ "irem",
/*71              */ "lrem",
/*72              */ "frem",
/*73              */ "drem",
/*74              */ "ineg",
/*75              */ "lneg",
/*76              */ "fneg",
/*77              */ "dneg",
/*78              */ "ishl",
/*79              */ "lshl",
/*7a              */ "ishr",
/*7b              */ "lshr",
/*7c              */ "iushr",
/*7d              */ "lushr",
/*7e              */ "iand",
/*7f              */ "land",
/*80              */ "ior",
/*81              */ "lor",
/*82              */ "ixor",
/*83              */ "lxor",
/*84 xx yy        */ "iinc              ",
/*85              */ "i2l",
/*86              */ "i2f",
/*87              */ "i2d",
/*88              */ "l2i",
/*89              */ "l2f",
/*8a              */ "l2d",
/*8b              */ "f2i",
/*8c              */ "f2l",
/*8d              */ "f2d",
/*8e              */ "d2i",
/*8f              */ "d2l",
/*90              */ "d2f",
/*91              */ "int2byte",
/*92              */ "int2char",
/*93              */ "int2short",
/*94              */ "lcmp",
/*95              */ "fcmpl",
/*96              */ "fcmpg",
/*97              */ "dcmpl",
/*98              */ "dcmpg",
/*99 xxxx         */ "ifeq            ",
/*9a xxxx         */ "ifne            ",
/*9b xxxx         */ "iflt            ",
/*9c xxxx         */ "ifge            ",
/*9d xxxx         */ "ifgt            ",
/*9e xxxx         */ "ifle            ",
/*9f xxxx         */ "if_icmpeq       ",
/*a0 xxxx         */ "if_icmpne       ",
/*a1 xxxx         */ "if_icmplt       ",
/*a2 xxxx         */ "if_icmpge       ",
/*a3 xxxx         */ "if_icmpgt       ",
/*a4 xxxx         */ "if_icmple       ",
/*a5 xxxx         */ "if_acmpeq       ",
/*a6 xxxx         */ "if_acmpne       ",
/*a7 xxxx         */ "goto            ",
/*a8 xxxx         */ "jsr             ", 
/*a9 xx           */ "ret             ",
/*aa [..]         */ "tableswitch  ",
/*ab [..]         */ "lookupswitch ",
/*ac              */ "ireturn",
/*ad              */ "lreturn",
/*ae              */ "freturn",
/*af              */ "dreturn",
/*b0              */ "areturn",
/*b1              */ "return",
/*b2 xxxx         */ "getstatic       ",
/*b3 xxxx         */ "putstatic       ",
/*b4 xxxx         */ "getfield        ",
/*b5 xxxx         */ "putfield        ",
/*b6 xxxx         */ "invokevirtual   ",
/*b7 xxxx         */ "invokenonvirtual",
/*b8 xxxx         */ "invokestatic    ",
/*b9 xxxx nn (nn) */ "invokeinterface ",
/*ba              */ "ungueltiger opcode", 
/*bb xxxx         */ "new             ",
/*bc              */ "newarray",
/*
bc 04            "newarray  T_BOOLEAN",
bc 05            "newarray  T_CHAR",
bc 06            "newarray  T_FLOAT",
bc 07            "newarray  T_DOUBLE",
bc 08            "newarray  T_BYTE",
bc 09            "newarray  T_SHORT",
bc 0a            "newarray  T_INT",
bc 0b            "newarray  T_LONG",
*/
/*bd xxxx         */ "anewarray       ",
/*be              */ "arraylength",
/*bf              */ "athrow",
/*c0 xxxx         */ "checkcast       ",
/*c1 xxxx         */ "instanceof      ",
/*c2              */ "monitorenter",
/*c3              */ "monitorexit",
/*c4 xx yy xx     */ "",
/*
c4 xx 15 xx      "iload",
c4 xx 16 xx      "lload",
c4 xx 17 xx      "fload",
c4 xx 18 xx      "dload",
c4 xx 19 xx      "aload",
c4 xx 36 xx      "istore",
c4 xx 37 xx      "lstore",
c4 xx 38 xx      "fstore",
c4 xx 39 xx      "dstore",
c4 xx 3a xx      "astore",
c4 xx 84 xx yy   "iinc",
*/
/*c5 xxxx yy      */ "multianewarray  ",
/*c6 xxxx         */ "ifnull          ",
/*c7 xxxx         */ "ifnonnull       ",
/*c8 xxxxxxxx     */ "goto_w      ",
/*c9 xxxxxxxx     */ "jsr_w       ",
/*ca              */ "breakpoint",
/*cb              */ "ungueltiger opcode", 
/*cc              */ "ungueltiger opcode",
/*cd              */ "ungueltiger opcode",
/*ce              */ "ungueltiger opcode",
/*cf              */ "ungueltiger opcode",
/*d0              */ "ungueltiger opcode",
/*d1 xxxx         */ "ret_w           ",
/*d2              */ "ungueltiger opcode"
};

 static char typ[256] = {
/*     0 1 2 3  4 5 6 7 8 9 a b c d e f 0 1 2 3 4 5 6 7 8 9  a b c d e f */ 
/*0*/  0,0,0,0, 0,0,0,0,0,0,0,0,0,0,0,0,1,2,1,2,2,1,1,1,1,1, 0,0,0,0,0,0,
/*2*/  0,0,0,0, 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1, 1,0,0,0,0,0,
/*4*/  0,0,0,0, 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, 0,0,0,0,0,0,
/*6*/  0,0,0,0, 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, 0,0,0,0,0,0,
/*8*/  0,0,0,0, 4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6, 6,6,6,6,6,6,
/*a*/  6,6,6,6, 6,6,6,6,6,1,7,8,0,0,0,0,0,0,2,2,2,2,2,2,2,9,10,2,0,2,0,0,
/*c*/  2,2,0,0,11,5,2,2,3,3,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0, 0,0,0,0,0,0,
/*e*/  0,0,0,0, 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, 0,0,0,0,0,0};


 l=posf; j=posf+i;
 posn++;
 while (posf<j)
   {nested[posn]=posf-l; k=get1(); if (k>0xd2) k=0xd2; 
    switch (typ[k])
     {case 0: out_code(); out_string(mnem[k]); break;
      case 1: m=get1(); out_code(); out_string(mnem[k]); 
              out_string("  "); out_hex1(m); break;
      case 2: m=get2(); out_code(); out_string(mnem[k]); 
              out_string("  "); out_hex2(m); break;
      case 3: m=get4(); out_code(); out_string(mnem[k]); 
              out_string("  "); out_hex4(m); break;
      case 4: m=get1(); n=get1(); out_code(); out_string(mnem[k]); 
              out_string("  "); out_hex1(m);
              out_string(","); out_hex1(n); break;
      case 5: m=get2(); n=get1(); out_code(); out_string(mnem[k]); 
              out_string("  "); out_hex2(m);
              out_string(","); out_hex1(n); break;
      case 6: m=get2(); out_code(); out_string(mnem[k]); 
              out_string("  "); out_hex2(m+nested[posn]); break;
      case 7: for (m=(nested[posn]&3)^3; m>0; m--) get1(); 
              m=get4(); n=get4(); o=get4();
              out_code(); out_string(mnem[k]); 
              out_string("  "); out_hex4(m+nested[posn]);
              out_string(","); out_hex4(n);
              out_string(","); out_hex2(o); 
              posn++; nested[posn]=n; 
              while (nested[posn] <= o)
                {m=get4(); out_code(); out_hex4(m+nested[posn-1]);
                 nested[posn]++;} 
              posn--;  out_string("\n");
              break;
      case 8: for (m=(nested[posn]&3)^3; m>0; m--) get1(); 
              m=get4(); n=get4();
              out_code(); out_string(mnem[k]); 
              out_string("  "); out_hex4(m+nested[posn]);
              out_string(","); out_hex4(n);
              posn++; nested[posn]=0; 
              while (nested[posn] < n)
                {m=get4(); o=get4(); out_code(); 
                 out_hex4(m); out_string(" : "); out_hex4(o+nested[posn-1]);
                 nested[posn]++;} 
              posn--;  out_string("\n");
              break;
      case 9: m=get2(); n=get1(); o=get1(); out_code(); out_string(mnem[k]); 
              out_string("  "); out_hex2(m);
              out_string(","); out_hex1(n);
              out_string(","); out_hex1(o); break;
      case 10:m=get1(); out_code(); out_string(mnem[k]); 
              out_string("  "); 
              switch (m) 
               {
                case  4: out_string("T_BOOLEAN"); break;
                case  5: out_string("T_CHAR"); break;
                case  6: out_string("T_FLOAT"); break;
                case  7: out_string("T_DOUBLE"); break;
                case  8: out_string("T_BYTE"); break;
                case  9: out_string("T_SHORT"); break;
                case 10: out_string("T_INT"); break;
                case 11: out_string("T_LONG"); break;
                default: ende(19,9);
               }
              break;

      case 11:m=get1(); n=get1();
              if ( n<0x15 || (n>0x19 && n<0x36) || (n>0x3a && n!=0x84) )
                 ende(20,10);
              m=(m<<8)+get1(); out_code(); out_string(mnem[n]); 
              out_string("  "); out_hex2(m); break;
              
      default: ende(21,11);
     }
   }
  if (posf!=j) ende(22,8);
 posn--;  out_string("\n");
}
 
/***********************************************************************/

int ende(j,i) int j,i;

{char *p;
 static char *(meld[]) = {

/*  0 */ "no errors" ,
/*  1 */ "can't open input file" ,
/*  2 */ "can't open output file" ,
/*  3 */ "unexpected end of input file" ,
/*  4 */ "no magic word" ,
/*  5 */ "buffer overrun" ,
/*  6 */ "invalid Constant Typ" ,
/*  7 */ "invalid length for Attribute" ,
/*  8 */ "unexpected end of Code" ,
/*  9 */ "invalid typ for Newarray" ,
/* 10 */ "invalid wide prefix" ,
/* 11 */ "you should never read this error message" ,
/* 12 */ "utf8 error" ,
/* 13 */ "usage: showjava infile outfile" ,
/* 14 */ "unicode with odd byte count" ,

};
 if (i || lst!=stdout)
      {print_string("\n"); 
       if (i) {print_string("error "); print_dec(j); print_string(" : ");}
       print_string(meld[i]); print_string("\n");
      }
  
 if (cla!=NULL) fclose(cla);
 if (lst!=NULL && lst!=stdout) fclose(lst); 
 exit(0);
}

/***********************************************************************/

int print_dec(i) int i;
{int k,j=1;
 if (i<0) {putc('-',stdout); i = -i;}
 k=i;
 while (k /= 10) j *= 10;
 while (j)
     {k=i/j;
      putc(k+'0',stdout);
      i -= k*j;
      j /= 10;
     }
}

/***********************************************************************/

int print_string(p) char *p;
{while (*p) putc(*p++,stdout);}

/***********************************************************************/


